Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/molecules.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -2333,263 +2422,4 @@
 };
 
-/** Splits up a molecule into atomic, non-hydrogen, hydrogen-saturated fragments.
- * \param *out output stream for debugging
- * \param NumberOfTopAtoms number to initialise second parameter of MoleculeListClass with
- * \param IsAngstroem whether atomic coordination is in Angstroem (true) or atomic length/bohrradous (false)
- * \param factor additional factor TE and forces factors are multiplied with
- * \param CutCyclic whether to add cut cyclic bond or to saturate
- * \return MoleculelistClass of pointer to each atomic fragment.
- */
-MoleculeListClass * molecule::GetAtomicFragments(ofstream *out, int NumberOfTopAtoms, bool IsAngstroem, double factor, enum CutCyclicBond CutCyclic)
-{
-  atom *TopAtom = NULL, *BottomAtom = NULL; // Top = this, Bottom = AtomicFragment->ListOfMolecules[No]
-  atom *Walker = NULL;
-  MoleculeListClass *AtomicFragments = NULL;
-  atom **AtomList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::GetAtomicFragments: **AtomList");
-  for (int i=0;i<AtomCount;i++)
-    AtomList[i] = NULL;
-  bond **BondList = (bond **) Malloc(sizeof(bond *)*BondCount, "molecule::GetAtomicFragments: **AtomList");
-  for (int i=0;i<BondCount;i++)
-    BondList[i] = NULL;
-  int No = 0, Cyclic;
-
-  *out << Verbose(0) << "Begin of GetAtomicFragments." << endl;
-
-  *out << Verbose(1) << "Atoms in Molecule: ";
-  Walker = start;
-  while (Walker->next != end) {
-    Walker = Walker->next;
-    *out << Walker << "\t";
-  } 
-  *out << endl;
-#ifdef ADDHYDROGEN
-  if (NoNonHydrogen != 0) {
-    AtomicFragments = new MoleculeListClass(NoNonHydrogen, NumberOfTopAtoms);
-  } else {
-    *out << Verbose(1) << "NoNonHydrogen is " << NoNonHydrogen << ", can't allocated MoleculeListClass." << endl;
-#else
-  if (AtomCount != 0) {
-    AtomicFragments = new MoleculeListClass(AtomCount, NumberOfTopAtoms);
-  } else {
-    *out << Verbose(1) << "AtomCount is " << AtomCount << ", can't allocated MoleculeListClass." << endl;
-#endif
-    return (AtomicFragments);
-  }
-  
-  TopAtom = start;
-  while (TopAtom->next != end) {
-    TopAtom = TopAtom->next;
-  //for(int i=0;i<AtomCount;i++) {
-#ifdef ADDHYDROGEN
-    if (TopAtom->type->Z != 1) {   // regard only non-hydrogen
-#endif
-      //TopAtom = AtomsInMolecule[i];
-      *out << Verbose(1) << "Current non-Hydrogen Atom: " << TopAtom->Name << endl;
-
-      // go through all bonds to check if cyclic
-      Cyclic = 0;
-      for(int i=0;i<NumberOfBondsPerAtom[TopAtom->nr];i++)
-        Cyclic += (ListOfBondsPerAtom[TopAtom->nr][i]->Cyclic) ? 1 : 0;
-
-#ifdef ADDHYDROGEN
-      if (No > NoNonHydrogen) {
-#else
-      if (No > AtomCount) {
-#endif
-        *out << Verbose(1) << "Access on created AtomicFragmentsListOfMolecules[" << No << "] beyond NumberOfMolecules " << AtomicFragments->NumberOfMolecules << "." << endl;
-        break;
-      }
-      if (AtomList[TopAtom->nr] == NULL) {
-        // create new molecule
-        AtomicFragments->ListOfMolecules[No] = new molecule(elemente); // allocate memory
-        AtomicFragments->TEList[No] = factor;
-        AtomicFragments->ListOfMolecules[No]->BondDistance = BondDistance;
-        
-        // add central atom
-        BottomAtom = AtomicFragments->ListOfMolecules[No]->AddCopyAtom(TopAtom); // add this central atom to molecule
-        AtomList[TopAtom->nr] = BottomAtom; // mark down in list
-
-        // create fragment          
-        *out << Verbose(1) << "New fragment around atom: " << TopAtom->Name << endl;
-        BreadthFirstSearchAdd(out,AtomicFragments->ListOfMolecules[No], AtomList, BondList, TopAtom, NULL, 0, IsAngstroem, (Cyclic == 0) ? SaturateBond : CutCyclic);
-        AtomicFragments->ListOfMolecules[No]->CountAtoms(out);
-        // actually we now have to reset both arrays to NULL again, but BFS is overkill anyway for getting the atomic fragments
-        // thus we do it in O(1) and avoid the O(n) which would make this routine O(N^2)!  
-        AtomList[TopAtom->nr] = NULL;  // remove this fragment's central atom again from the list
-        
-        *out << Verbose(1) << "Atoms in Fragment " << TopAtom->nr << ": ";
-        Walker = AtomicFragments->ListOfMolecules[No]->start;
-        while (Walker->next != AtomicFragments->ListOfMolecules[No]->end) {
-          Walker = Walker->next; 
-        //for(int k=0;k<AtomicFragments->ListOfMolecules[No]->AtomCount;k++)
-          *out << Walker << "(" << Walker->father << ")\t";
-        }
-        *out << endl;
-        No++;
-      }
-#ifdef ADDHYDROGEN
-    } else
-      *out << Verbose(1) << "Current Hydrogen Atom: " << TopAtom->Name << endl;
-#endif
-  }
-
-  // output of full list before reduction
-  if (AtomicFragments != NULL) {
-    *out << "AtomicFragments: ";
-    AtomicFragments->Output(out);
-    *out << endl;
-  } else 
-    *out << Verbose(1) << "AtomicFragments is zero on return, splitting failed." << endl;
-
-  // Reducing the atomic fragments
-  if (AtomicFragments != NULL) {
-    // check whether there are equal fragments by GetMappingToUniqueFragments
-    AtomicFragments->ReduceToUniqueList(out, &cell_size[0], BondDistance);
-  } else
-    *out << Verbose(1) << "AtomicFragments is zero, reducing failed." << endl;
-  Free((void **)&BondList, "molecule::GetAtomicFragments: **BondList");
-  Free((void **)&AtomList, "molecule::GetAtomicFragments: **AtomList");
-  *out << Verbose(0) << "End of GetAtomicFragments." << endl;
-  return (AtomicFragments);
-};
-
-/** Splits up the bond in a molecule into a left and a right fragment.
- * \param *out output stream for debugging
- * \param *Bond bond to broken up into getting allocated ...
- * \param *LeftFragment ... left fragment molecule ... (ptr to the memory cell wherein the adress for the Fragment is to be stored)
- * \param *RightFragment ... and right fragment molecule to be returned.(ptr to the memory cell wherein the adress for the Fragment is to be stored)
- * \param IsAngstroem whether atomic coordination is in Angstroem (true) or atomic length/bohrradous (false)
- * \param CutCyclic whether to add cut cyclic bond or not
- * \sa FragmentTopDown()
- */
-void molecule::FragmentMoleculeByBond(ofstream *out, bond *Bond, molecule **LeftFragment, molecule **RightFragment, bool IsAngstroem, enum CutCyclicBond CutCyclic)
-{
-  *out << Verbose(0) << "Begin of FragmentMoleculeByBond." << endl; 
-#ifdef ADDHYDROGEN
-  if ((Bond->leftatom->type->Z != 1) && (Bond->rightatom->type->Z != 1)) { // if both bond partners aren't hydrogen ...
-#endif    
-    *out << Verbose(1) << "Current Non-Hydrogen Bond: " << Bond->leftatom->Name << " and " << Bond->rightatom->Name << endl;
-    *LeftFragment = new molecule(elemente);
-    *RightFragment = new molecule(elemente);
-    // initialise marker list for all atoms
-    atom **AddedAtomListLeft = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::FragmentMoleculeByBond: **AddedAtomListLeft");
-    atom **AddedAtomListRight = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::FragmentMoleculeByBond: **AddedAtomListRight");
-    for (int i=0;i<AtomCount;i++) {
-      AddedAtomListLeft[i] = NULL;
-      AddedAtomListRight[i] = NULL;
-    }
-    bond **AddedBondListLeft = (bond **) Malloc(sizeof(bond *)*BondCount, "molecule::FragmentMoleculeByBond: **AddedBondListLeft");
-    bond **AddedBondListRight = (bond **) Malloc(sizeof(bond *)*BondCount, "molecule::FragmentMoleculeByBond: **AddedBondListRight");
-    for (int i=0;i<BondCount;i++) {
-      AddedBondListLeft[i] = NULL;
-      AddedBondListRight[i] = NULL;
-    }
-  
-    // tag and add all atoms that have to be included
-    *out << Verbose(1) << "Adding BFS-wise on left hand side with Bond Order " << NoNonBonds-1 << "." << endl;
-    AddedAtomListLeft[Bond->leftatom->nr] = (*LeftFragment)->AddCopyAtom(Bond->leftatom);
-    BreadthFirstSearchAdd(out, *LeftFragment, AddedAtomListLeft, AddedBondListLeft, Bond->leftatom, Bond, 
-#ifdef ADDHYDROGEN
-    NoNonBonds
-#else
-    BondCount
-#endif    
-                                                                                                            , IsAngstroem, CutCyclic);
-    *out << Verbose(1) << "Adding BFS-wise on right hand side with Bond Order " << NoNonBonds-1 << "." << endl;
-    AddedAtomListRight[Bond->rightatom->nr] = (*RightFragment)->AddCopyAtom(Bond->rightatom);
-    BreadthFirstSearchAdd(out, *RightFragment, AddedAtomListRight, AddedBondListRight, Bond->rightatom, Bond, 
-#ifdef ADDHYDROGEN
-    NoNonBonds
-#else
-    BondCount
-#endif    
-                                                                                                            , IsAngstroem, CutCyclic);  
- 
-    // count atoms
-    (*LeftFragment)->CountAtoms(out);
-    (*RightFragment)->CountAtoms(out);
-    // free all and exit
-    Free((void **)&AddedAtomListLeft, "molecule::FragmentMoleculeByBond: **AddedAtomListLeft");
-    Free((void **)&AddedAtomListRight, "molecule::FragmentMoleculeByBond: **AddedAtomListRight");
-    Free((void **)&AddedBondListLeft, "molecule::FragmentMoleculeByBond: **AddedBondListLeft");
-    Free((void **)&AddedBondListRight, "molecule::FragmentMoleculeByBond: **AddedBondListRight");
-#ifdef ADDHYDROGEN
-  }
-#endif
-  *out << Verbose(0) << "End of FragmentMoleculeByBond." << endl;
-};
-
-/** Returns the given \a **FragmentList filled with molecules around each bond including up to \a BondDegree neighbours.
- * \param *out output stream for debugging
- * \param BondOrder neighbours on each side to be ...
- * \param IsAngstroem whether atomic coordination is in Angstroem (true) or atomic length/bohrradous (false)
- * \param CutCyclic whether to add cut cyclic bond or to saturate
- * \sa FragmentBottomUp(), molecule::AddBondOrdertoMolecule()
- */
-MoleculeListClass * molecule::GetEachBondFragmentOfOrder(ofstream *out, int BondOrder, bool IsAngstroem, enum CutCyclicBond CutCyclic)
-{
-  /// Allocate memory for Bond list and go through each bond and fragment molecule up to bond order and fill the list to be returned.
-  MoleculeListClass *FragmentList = NULL;
-  atom **AddedAtomList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::GetBondFragmentOfOrder: **AddedAtomList");
-  bond **AddedBondList = (bond **) Malloc(sizeof(bond *)*BondCount, "molecule::GetBondFragmentOfOrder: **AddedBondList");
-  bond *Binder = NULL;
-
-  *out << Verbose(0) << "Begin of GetEachBondFragmentOfOrder." << endl;
-#ifdef ADDHYDROGEN
-  if (NoNonBonds != 0) {
-    FragmentList = new MoleculeListClass(NoNonBonds, AtomCount);
-  } else {
-    *out << Verbose(1) << "NoNonBonds is " << NoNonBonds << ", can't allocate list." << endl;
-#else
-  if (BondCount != 0) {
-    FragmentList = new MoleculeListClass(BondCount, AtomCount);
-  } else {
-    *out << Verbose(1) << "BondCount is " << BondCount << ", can't allocate list." << endl;
-#endif
-  }
-  int No = 0;
-  Binder = first;
-  while (Binder->next != last) { // get each bond, NULL is returned if it is a H-H bond
-    Binder = Binder->next;
-#ifdef ADDHYDROGEN
-    if ((Binder->leftatom->type->Z != 1) && (Binder->rightatom->type->Z != 1))  // if both bond partners aren't hydrogen ...
-#endif
-      if ((CutCyclic == SaturateBond) || (!Binder->Cyclic)) {
-        *out << Verbose(1) << "Getting Fragment for Non-Hydrogen Bond: " << Binder->leftatom->Name << " and " << Binder->rightatom->Name << endl;
-        FragmentList->ListOfMolecules[No] = new molecule(elemente);
-        // initialise marker list for all atoms
-        for (int i=0;i<AtomCount;i++)
-          AddedAtomList[i] = NULL;
-        for (int i=0;i<BondCount;i++)
-          AddedBondList[i] = NULL;
-      
-        // add root bond as first bond (this is needed later on fragmenting)
-        *out << Verbose(1) << "Adding Root Bond " << *Binder << " and its atom." << endl;
-        AddedAtomList[Binder->leftatom->nr] = FragmentList->ListOfMolecules[No]->AddCopyAtom(Binder->leftatom);
-        AddedAtomList[Binder->rightatom->nr] = FragmentList->ListOfMolecules[No]->AddCopyAtom(Binder->rightatom);
-        AddedBondList[Binder->nr] = FragmentList->ListOfMolecules[No]->AddBond(AddedAtomList[Binder->leftatom->nr], AddedAtomList[Binder->rightatom->nr], Binder->BondDegree);
-    
-        // tag and add all atoms that have to be included
-        *out << Verbose(1) << "Adding BFS-wise on left hand side." << endl;
-        BreadthFirstSearchAdd(out, FragmentList->ListOfMolecules[No], AddedAtomList, AddedBondList, Binder->leftatom, NULL, BondOrder, IsAngstroem, CutCyclic);  
-        *out << Verbose(1) << "Adding BFS-wise on right hand side." << endl;
-        BreadthFirstSearchAdd(out, FragmentList->ListOfMolecules[No], AddedAtomList, AddedBondList, Binder->rightatom, NULL, BondOrder, IsAngstroem, CutCyclic);  
-        
-        // count atoms
-        FragmentList->ListOfMolecules[No]->CountAtoms(out);
-        FragmentList->TEList[No] = 1.;
-        *out << Verbose(1) << "GetBondFragmentOfOrder: " << Binder->nr << "th Fragment: " << FragmentList->ListOfMolecules[No] << "." << endl;
-        No++;
-      }
-  }
-  // free all lists
-  Free((void **)&AddedAtomList, "molecule::GetBondFragmentOfOrder: **AddedAtomList");
-  Free((void **)&AddedBondList, "molecule::GetBondFragmentOfOrder: **AddedBondList");
-  // output and exit
-  FragmentList->Output(out);
-  *out << Verbose(0) << "End of GetEachBondFragmentOfOrder." << endl;
-  return (FragmentList);
-}; 
-
 /** Adds atoms up to \a BondCount distance from \a *Root and notes them down in \a **AddedAtomList.
  * Gray vertices are always enqueued in an AtomStackClass FIFO queue, the rest is usual BFS with adding vertices found was
@@ -2603,7 +2433,6 @@
  * \param BondOrder maximum distance for vertices to add
  * \param IsAngstroem lengths are in angstroem or bohrradii
- * \param CutCyclic whether to cut cyclic bonds (means saturate on need with hydrogen) or to always add
  */  
-void molecule::BreadthFirstSearchAdd(ofstream *out, molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem, enum CutCyclicBond CutCyclic)
+void molecule::BreadthFirstSearchAdd(ofstream *out, molecule *Mol, atom **&AddedAtomList, bond **&AddedBondList, atom *Root, bond *Bond, int BondOrder, bool IsAngstroem)
 {
   atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::BreadthFirstSearchAdd: **PredecessorList");
@@ -2650,5 +2479,5 @@
           ShortestPathList[OtherAtom->nr] = ShortestPathList[Walker->nr]+1;
           *out << Verbose(2) << "Coloring OtherAtom " << OtherAtom->Name << " " << ((ColorList[OtherAtom->nr] == white) ? "white" : "lightgray") << ", its predecessor is " << Walker->Name << " and its Shortest Path is " << ShortestPathList[OtherAtom->nr] << " egde(s) long." << endl; 
-          if ((((ShortestPathList[OtherAtom->nr] < BondOrder) && (Binder != Bond)) || (Binder->Cyclic && (CutCyclic == KeepBond))) ) { // Check for maximum distance
+          if ((((ShortestPathList[OtherAtom->nr] < BondOrder) && (Binder != Bond))) ) { // Check for maximum distance
             *out << Verbose(3);
             if (AddedAtomList[OtherAtom->nr] == NULL) { // add if it's not been so far
@@ -2678,10 +2507,8 @@
             else if (ShortestPathList[OtherAtom->nr] >= BondOrder)
               *out << Verbose(3) << "Not Queueing, is out of Bond Count of " << BondOrder;
-            if ((Binder->Cyclic && (CutCyclic != KeepBond)))
-              *out << ", is part of a cyclic bond yet we don't keep them, saturating bond with Hydrogen." << endl;
             if (!Binder->Cyclic)
               *out << ", is not part of a cyclic bond, saturating bond with Hydrogen." << endl;
             if (AddedBondList[Binder->nr] == NULL) {
-              if ((AddedAtomList[OtherAtom->nr] != NULL) && (CutCyclic == KeepBond)) { // .. whether we add or saturate
+              if ((AddedAtomList[OtherAtom->nr] != NULL)) { // .. whether we add or saturate
                 AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
                 AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
@@ -2698,5 +2525,5 @@
           // This has to be a cyclic bond, check whether it's present ...
           if (AddedBondList[Binder->nr] == NULL) {
-            if ((Binder != Bond) && (Binder->Cyclic) && (((ShortestPathList[Walker->nr]+1) < BondOrder) || (CutCyclic == KeepBond))) { 
+            if ((Binder != Bond) && (Binder->Cyclic) && (((ShortestPathList[Walker->nr]+1) < BondOrder))) { 
               AddedBondList[Binder->nr] = Mol->AddBond(AddedAtomList[Walker->nr], AddedAtomList[OtherAtom->nr], Binder->BondDegree);
               AddedBondList[Binder->nr]->Cyclic = Binder->Cyclic;
@@ -3106,5 +2933,4 @@
   bool **UsedList;
   bond **BondsPerSPList;
-  double TEFactor;
   int *BondsPerSPCount;
 };
@@ -3165,5 +2991,5 @@
           *out << Verbose(2+verbosity) << "Adding " << *OtherWalker << " with nr " << OtherWalker->nr << "." << endl;
           TouchedList[TouchedIndex++] = OtherWalker->nr;  // note as added
-          FragmentSearch->FragmentSet->insert(OtherWalker->GetTrueFather()->nr);
+          FragmentSearch->FragmentSet->insert(OtherWalker->nr);
             //FragmentSearch->UsedList[OtherWalker->nr][i] = true;
           //}
@@ -3205,10 +3031,9 @@
         *out << Verbose(1+verbosity) << "Enough items on stack for a fragment!" << endl;
         // store fragment as a KeySet
-        *out << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], indices are: ";
-        for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++) {
-          *out << (*runner)+1 << " "; 
-        }
+        *out << Verbose(2) << "Found a new fragment[" << FragmentSearch->FragmentCounter << "], local nr.s are: ";
+        for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
+          *out << (*runner) << " "; 
         InsertFragmentIntoGraph(out, FragmentSearch);
-        Removal = LookForRemovalCandidate(out, FragmentSearch->FragmentSet, FragmentSearch->ShortestPathList);
+        //Removal = LookForRemovalCandidate(out, FragmentSearch->FragmentSet, FragmentSearch->ShortestPathList);
         //Removal = StoreFragmentFromStack(out, FragmentSearch->Root, FragmentSearch->Leaflet, FragmentSearch->FragmentStack, FragmentSearch->ShortestPathList,FragmentSearch->Labels, &FragmentSearch->FragmentCounter, FragmentSearch->configuration);
       }
@@ -3218,8 +3043,12 @@
       for(int j=0;j<TouchedIndex;j++) {
         Removal = TouchedList[j];
-        *out << Verbose(2+verbosity) << "Removing item nr. " << Removal+1 << " from snake stack." << endl;
+        *out << Verbose(2+verbosity) << "Removing item nr. " << Removal << " from snake stack." << endl;
         FragmentSearch->FragmentSet->erase(Removal);
         TouchedList[j] = -1;
       }
+      *out << Verbose(2) << "Remaining local nr.s on snake stack are: ";
+      for(KeySet::iterator runner = FragmentSearch->FragmentSet->begin(); runner != FragmentSearch->FragmentSet->end(); runner++)
+        *out << (*runner) << " "; 
+      *out << endl;
       TouchedIndex = 0; // set Index to 0 for list of atoms added on this level
     } else {
@@ -3228,42 +3057,40 @@
   }
   Free((void **)&TouchedList, "molecule::SPFragmentGenerator: *TouchedList");  
-  *out << Verbose(1+verbosity) << "End of SPFragmentGenerator " << RootDistance << " away from Root " << *FragmentSearch->Root << " and SubOrder is " << SubOrder << "." << endl;
-};
-
-/** Creates a list of all unique fragments of certain vertex size from a given graph \a Fragment in the context of \a this molecule.
+  *out << Verbose(1+verbosity) << "End of SPFragmentGenerator, " << RootDistance << " away from Root " << *FragmentSearch->Root << " and SubOrder is " << SubOrder << "." << endl;
+};
+
+/** Creates a list of all unique fragments of certain vertex size from a given graph \a Fragment for a given root vertex in the context of \a this molecule.
  * Note that we may use the fact that the atoms are SP-ordered on the atomstack. I.e. when popping always the last, we first get all
  * with SP of 2, then those with SP of 3, then those with SP of 4 and so on.
  * \param *out output stream for debugging
- * \param Order number of vertices
- * \param *ListOfGraph Graph structure to insert found fragments into
- * \param Fragment Restricted vertex set to use in context of molecule
- * \param TEFactor TEFactor to store in graphlist in the end
- * \param *configuration configuration needed for IsAngstroem
+ * \param Order bond order (limits BFS exploration and "number of digits" in power set generation 
+ * \param *ReturnKeySets Graph structure to insert found keysets/fragments into
+ * \param RestrictedKeySet Restricted vertex set to use in context of molecule
+ * \param RootKeyNr Atom::nr of the atom acting as current fragment root 
  * \return number of inserted fragments
  * \note ShortestPathList in FragmentSearch structure is probably due to NumberOfAtomsSPLevel and SP not needed anymore
  */
-int molecule::CreateListOfUniqueFragmentsOfOrder(ofstream *out, int Order, Graph *ListOfGraph, KeySet Fragment, double TEFactor, config *configuration) 
-{
-  int SP, UniqueIndex, RootKeyNr, AtomKeyNr;
-  int *NumberOfAtomsSPLevel = (int *) Malloc(sizeof(int)*Order, "molecule::CreateListOfUniqueFragmentsOfOrder: *SPLevelCount");
+int molecule::PowerSetGenerator(ofstream *out, int Order, Graph *ReturnKeySets, KeySet RestrictedKeySet, int RootKeyNr) 
+{
+  int SP, UniqueIndex, AtomKeyNr;
+  int *NumberOfAtomsSPLevel = (int *) Malloc(sizeof(int)*Order, "molecule::PowerSetGenerator: *SPLevelCount");
   atom *Walker = NULL, *OtherWalker = NULL;
   bond *Binder = NULL;
   bond **BondsList = NULL;
-  KeyStack RootStack;
   KeyStack AtomStack;
-  atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::CreateListOfUniqueFragmentsOfOrder: **PredecessorList");
+  atom **PredecessorList = (atom **) Malloc(sizeof(atom *)*AtomCount, "molecule::PowerSetGenerator: **PredecessorList");
   KeySet::iterator runner;
+  //int Count = RestrictedKeySet.size();
 
   // initialise the fragments structure
   struct UniqueFragments FragmentSearch;
-  FragmentSearch.BondsPerSPList = (bond **) Malloc(sizeof(bond *)*Order*2, "molecule::CreateListOfUniqueFragmentsOfOrder: ***BondsPerSPList");
-  FragmentSearch.BondsPerSPCount = (int *) Malloc(sizeof(int)*Order, "molecule::CreateListOfUniqueFragmentsOfOrder: *BondsPerSPCount");
-  FragmentSearch.ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CreateListOfUniqueFragmentsOfOrder: *ShortestPathList");
-  FragmentSearch.Labels = (int *) Malloc(sizeof(int)*AtomCount, "molecule::CreateListOfUniqueFragmentsOfOrder: *Labels");
+  FragmentSearch.BondsPerSPList = (bond **) Malloc(sizeof(bond *)*Order*2, "molecule::PowerSetGenerator: ***BondsPerSPList");
+  FragmentSearch.BondsPerSPCount = (int *) Malloc(sizeof(int)*Order, "molecule::PowerSetGenerator: *BondsPerSPCount");
+  FragmentSearch.ShortestPathList = (int *) Malloc(sizeof(int)*AtomCount, "molecule::PowerSetGenerator: *ShortestPathList");
+  FragmentSearch.Labels = (int *) Malloc(sizeof(int)*AtomCount, "molecule::PowerSetGenerator: *Labels");
   FragmentSearch.FragmentCounter = 0;
   FragmentSearch.FragmentSet = new KeySet;
-  FragmentSearch.configuration = configuration;
-  FragmentSearch.TEFactor = TEFactor;
-  FragmentSearch.Leaflet = ListOfGraph;      // set to insertion graph
+  FragmentSearch.Leaflet = ReturnKeySets;      // set to insertion graph
+  FragmentSearch.Root = FindAtom(RootKeyNr);
   for (int i=0;i<AtomCount;i++) {
     FragmentSearch.Labels[i] = -1;
